src/Entity/MdmDevice.php
<?php


namespace App\Entity;

use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;

use Symfony\Component\Uid\Uuid;

/**
 * @ORM\Entity(repositoryClass="App\Repository\MdmDeviceRepository")
 * @UniqueEntity("serial")
 *
 */
class MdmDevice
{

    /**
     * @ORM\Id
     * @ORM\Column(type="uuid", unique=true)
     */
    private $id;

    /**
     * @ORM\Column(type="string", nullable=false)
     */
    private $serial;

    /**
     * @ORM\Column(type="string", nullable=false)
     */
    private $mac;

    /**
     * @ORM\Column(type="string", nullable=true)
     */
    private $ownerUsername;

    /**
     * @ORM\Column(type="string", nullable=true)
     */
    private $name;

    /**
     * @ORM\Column(type="string", nullable=true)
     */
    private $model;

    /**
     * @ORM\Column(type="string", nullable=true)
     */
    private $osVersion;

    /**
     * @ORM\Column(type="boolean")
     */
    private $fromDep;

    /**
     * @ORM\Column(type="boolean")
     */
    private $supervised;

    /**
     * @ORM\Column(type="string", nullable=true)
     */
    private $activationBypassCode;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $lastInfoUpdate;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $lastUpdate;

    /**
     * @ORM\Column(type="boolean", nullable=false)
     */
    protected $removed = false;

    /**
     * @ORM\ManyToOne(targetEntity="MdmServer", inversedBy="devices")
     **/
    private $mdmServer;

    /**
     * @ORM\Column(type="string", nullable=false)
     */
    private $idOnMdmServer;

    /**
     * @ORM\ManyToOne(targetEntity="Student", inversedBy="mdmDevices")
     * @ORM\JoinColumn(nullable=true, onDelete="SET NULL")
     * @var Student|null
     */
    protected $studentOwner;

    /**
     * @ORM\ManyToOne(targetEntity="Teacher", inversedBy="mdmDevices")
     * @ORM\JoinColumn(nullable=true, onDelete="SET NULL")
     * @var Teacher|null
     */
    protected $teacherOwner;

    public function __construct()
    {
        $this->id = Uuid::v4();
    }

    /**
     * @param \App\MdmConnector\ImportedEntity\Device $data
     * @throws \Exception
     */
    public function importData(\App\MdmConnector\ImportedEntity\Device $data)
    {
        $dataToCopy = ['serial', 'mac', 'ownerUsername', 'name', 'model', 'osVersion', 'fromDep', 'supervised', 'activationBypassCode', 'lastInfoUpdate', 'lastUpdate', 'studentOwner', 'teacherOwner'];

        foreach ($dataToCopy as $k) {
            $getter = "get" . ucfirst($k);
            if (!method_exists($data, $getter) || !property_exists($this, $k)) {
                throw new \Exception("Invalid property to import in MdmBook");
            }

            $this->$k = $data->$getter();
        }

        $this->idOnMdmServer = $data->getId();
    }

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @return string
     */
    public function getSerial()
    {
        return $this->serial;
    }

    /**
     * @param string $serial
     */
    public function setSerial($serial)
    {
        $this->serial = $serial;
    }

    /**
     * @return string
     */
    public function getMac()
    {
        return $this->mac;
    }

    /**
     * @param string $mac
     */
    public function setMac($mac)
    {
        $this->mac = $mac;
    }

    /**
     * @return string
     */
    public function getOwnerUsername()
    {
        return $this->ownerUsername;
    }

    /**
     * @param string $ownerUsername
     */
    public function setOwnerUsername($ownerUsername)
    {
        $this->ownerUsername = $ownerUsername;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @return string
     */
    public function getModel()
    {
        return $this->model;
    }

    /**
     * @param string $model
     */
    public function setModel($model)
    {
        $this->model = $model;
    }

    /**
     * @return string
     */
    public function getOsVersion()
    {
        return $this->osVersion;
    }

    /**
     * @param string $osVersion
     */
    public function setOsVersion($osVersion)
    {
        $this->osVersion = $osVersion;
    }

    /**
     * @return boolean
     */
    public function getFromDep()
    {
        return $this->fromDep;
    }

    /**
     * @param boolean $fromDep
     */
    public function setFromDep($fromDep)
    {
        $this->fromDep = $fromDep;
    }

    /**
     * @return boolean
     */
    public function getSupervised()
    {
        return $this->supervised;
    }

    /**
     * @param boolean $supervised
     */
    public function setSupervised($supervised)
    {
        $this->supervised = $supervised;
    }

    /**
     * @return string
     */
    public function getActivationBypassCode()
    {
        return $this->activationBypassCode;
    }

    /**
     * @param string $activationBypassCode
     */
    public function setActivationBypassCode($activationBypassCode)
    {
        $this->activationBypassCode = $activationBypassCode;
    }

    /**
     * @return \DateTime
     */
    public function getLastInfoUpdate()
    {
        return $this->lastInfoUpdate;
    }

    /**
     * @param \DateTime $lastInfoUpdate
     */
    public function setLastInfoUpdate($lastInfoUpdate)
    {
        $this->lastInfoUpdate = $lastInfoUpdate;
    }

    /**
     * @return \DateTime
     */
    public function getLastUpdate()
    {
        return $this->lastUpdate;
    }

    /**
     * @param \DateTime $lastUpdate
     */
    public function setLastUpdate($lastUpdate)
    {
        $this->lastUpdate = $lastUpdate;
    }

    /**
     * @return bool
     */
    public function getRemoved()
    {
        return $this->removed;
    }

    /**
     * @param bool $removed
     */
    public function setRemoved($removed)
    {
        $this->removed = $removed;
    }

    /**
     * @return MdmServer
     */
    public function getMdmServer()
    {
        return $this->mdmServer;
    }

    /**
     * @param MdmServer $mdmServer
     */
    public function setMdmServer($mdmServer)
    {
        $this->mdmServer = $mdmServer;
    }

    /**
     * @return string
     */
    public function getIdOnMdmServer()
    {
        return $this->idOnMdmServer;
    }

    /**
     * @param string $idOnMdmServer
     */
    public function setIdOnMdmServer($idOnMdmServer)
    {
        $this->idOnMdmServer = $idOnMdmServer;
    }

    /**
     * @return PersonAbstract|null
     */
    public function getOwner()
    {
        return $this->studentOwner ?? $this->teacherOwner;
    }

    /**
     * @return Student|null
     */
    public function getStudentOwner(): ?Student
    {
        return $this->studentOwner;
    }

    /**
     * @return Teacher|null
     */
    public function getTeacherOwner(): ?Teacher
    {
        return $this->teacherOwner;
    }

    public function isFromDep(): ?bool
    {
        return $this->fromDep;
    }

    public function isSupervised(): ?bool
    {
        return $this->supervised;
    }

    public function isRemoved(): ?bool
    {
        return $this->removed;
    }

    public function setStudentOwner(?Student $studentOwner): static
    {
        $this->studentOwner = $studentOwner;

        return $this;
    }

    public function setTeacherOwner(?Teacher $teacherOwner): static
    {
        $this->teacherOwner = $teacherOwner;

        return $this;
    }


}

src/Entity/Student.php
<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\Criteria;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;

/**
 * @ORM\Entity
 * @ORM\Table(name="Student")
 * @ORM\Entity(repositoryClass="App\Repository\StudentRepository")
 * @UniqueEntity("fiscalCode")
 * @UniqueEntity("username")
 * @UniqueEntity("email")
 */
class Student extends PersonAbstract
{
    /**
     * @ORM\ManyToMany(targetEntity="Group", inversedBy="students")
     * @ORM\JoinTable(name="students_groups",
     *  joinColumns={@ORM\JoinColumn(name="student_id", referencedColumnName="id")},
     *  inverseJoinColumns={@ORM\JoinColumn(name="group_id", referencedColumnName="id")}
     *      )
     * Serializer\MaxDepth(3)
     * Serializer\Groups({"student_groups"})
     * Serializer\SerializedName("groups")
     **/
    protected $memberOf;

    /**
     * Student constructor.
     *
     * @param $id
     */
    public function __construct($fiscalCode)
    {
        $this->memberOf = new \Doctrine\Common\Collections\ArrayCollection();
        parent::__construct($fiscalCode);
    }

    public function __clone()
    {
        parent::__clone();
        $this->memberOf = clone $this->memberOf;
    }

    /**
     * Add memberOf.
     *
     * @param \App\Entity\Group $memberOf
     *
     * @return PersonAbstract
     */
    public function addMemberOf(Group $memberOf)
    {
        if (!$this->isMemberOf($memberOf)) {
            $this->memberOf->add($memberOf);
        }

        return $this;
    }

    /**
     * Remove memberOf.
     *
     * @param \App\Entity\Group $memberOf
     */
    public function removeMemberOf(Group $memberOf)
    {
        $this->memberOf->removeElement($memberOf);
    }

    public function removeAllMemberOf()
    {
        foreach ($this->memberOf as $group) {
            $group->removeStudent($this);
        }
        $this->memberOf = new \Doctrine\Common\Collections\ArrayCollection();
    }

    /**
     * Get memberOf.
     *
     * @return Group[]|\Doctrine\Common\Collections\Collection
     */
    public function getMemberOf()
    {
        return $this->memberOf;
    }

    /**
     * @return Group[]|\Doctrine\Common\Collections\Collection
     */
    public function getGroups()
    {
        return $this->memberOf;
    }

    /**
     * @return Group[]|\Doctrine\Common\Collections\Collection
     */
    public function getNotManuallyManagedGroups()
    {
        $criteria = Criteria::create();
        $criteria->where(Criteria::expr()->eq('manageManually', false));

        return $this->memberOf->matching($criteria);
    }

    /**
     * @return Group[]|\Doctrine\Common\Collections\Collection|null
     */
    public function getNotManuallyManagedGroupOfProvider(Provider $provider)
    {
        $criteria = Criteria::create();
        $criteria->where(Criteria::expr()->andX(
            // @todo: sf34 aggiungere criterio provider_id ---> perchè non funziona come prima?
            Criteria::expr()->eq('manageManually', false),
//            Criteria::expr()->eq('provider_id', $provider->getId())
        ));

        $groups = $this->memberOf->matching($criteria);
        foreach ($groups as $group) {
            if ($group->getProvider()->getId() == $provider->getId()) {
                return $group;
            }
        }

        return null;
//        return isset($groups[0]) ? $groups[0] : null;
    }

    /**
     * @return Group[]|\Doctrine\Common\Collections\Collection
     */
    public function getManuallyManagedGroups()
    {
        $criteria = Criteria::create();
        $criteria->where(Criteria::expr()->eq('manageManually', true));

        return $this->memberOf->matching($criteria);
    }

    /**
     * check membership.
     *
     * @return bool
     */
    public function isMemberOf($groupToTest)
    {
        foreach ($this->memberOf as $group) {
            if ($group == $groupToTest) {
                return true;
            }
        }

        return false;
    }

    /**
     * @return bool
     */
    public function isSame(\App\ImporterFilter\ImportedEntity\Student $importedStudent, Provider $provider = null)
    {
        if (strtolower($this->fiscalCode) != strtolower($importedStudent->getFiscalCode())) {
            return false;
        }

        if ($this->firstname != $importedStudent->getFirstName()) {
            return false;
        }

        if ($this->lastname != $importedStudent->getLastName()) {
            return false;
        }

        if (null !== $importedStudent->getEmail() && strtolower($this->email) != strtolower($importedStudent->getEmail())) {
            return false;
        }

        if (null !== $importedStudent->getPassword() && $this->starting_password != $importedStudent->getPassword()) {
            return false;
        }
        if (null !== $importedStudent->getUsername() && strtolower($this->username) != strtolower($importedStudent->getUsername())) {
            return false;
        }

        if (null === $provider) {
            $provider = $this->getProvider();
        }

        $group = $this->getNotManuallyManagedGroupOfProvider($provider);
        if (null !== $importedStudent->getGroup()) {
            if (null === $group || $group->getId() != $importedStudent->getGroup()->getId()) {
                return false;
            }
        } elseif (null !== $group) {
            return false;
        }

        return true;
    }

    /**
     * @return bool
     */
    public function haveSameGroup(\App\ImporterFilter\ImportedEntity\Student $importedStudent, Provider $provider = null)
    {
        $group = $this->getNotManuallyManagedGroupOfProvider($provider);
        if (null !== $importedStudent->getGroup()) {
            if (null === $group || $group->getId() != $importedStudent->getGroup()->getId()) {
                return false;
            }
        } elseif (null !== $group) {
            return false;
        }

        return true;
    }

    /**
     * @return array
     */
    public function getProviderSettings()
    {
        if (!$this->provider instanceof Provider) {
            return Provider::$settingsFieldNulled;
        }

        return $this->provider->getStudentSettings();
    }
}

templates/mdm_device/index.html.twig
{% extends 'base.html.twig' %}

{% block body -%}
<main class='main-content'>
    <div id='mainContent'>
        <h1>Dispositivi Gestiti</h1>

        <table class="table table-striped table-hover ">
            <thead>
            <tr>
                <th><a href="{{ orderUrls.serial }}">Seriale</a></th>
                <th><a href="{{ orderUrls.name }}">Nome</a></th>
                <th>Mac Address</th>
                <th><a href="{{ orderUrls.osVersion }}">Os Version</a></th>
                <th>Dep</th>
                <th>Supervisionato</th>
                <th><a href="{{ orderUrls.orderByServer }}">Server MDM</a></th>
                <th><a href="{{ orderUrls.lastname }}">Proprietario</a></th>
                <th>Classe</th>
                <th><a href="{{ orderUrls.lastInfoUpdate }}">Ultimo Agg. Dati</a></th>
            </tr>
            </thead>
            <tbody>
            {% for paginatedDevice in paginatedDevices %}
                <tr>
                    <td>{{ paginatedDevice.serial }}</td>
                    <td>{{ paginatedDevice.name }}</td>
                    <td>{{ paginatedDevice.mac }}</td>
                    <td>{{ paginatedDevice.osVersion }}</td>
                    <td>{% if paginatedDevice.fromDep %}<i class="fas fa-check"></i>{% endif %}</td>
                    <td>{% if paginatedDevice.supervised %}<i class="fas fa-check"></i>{% endif %}</td>
                    <td>{{ paginatedDevice.mdmServer.name }}</td>
                    <td>{% if paginatedDevice.owner %}{{ paginatedDevice.owner.lastname }} {{ paginatedDevice.owner.firstname }}{% endif %}</td>
                    <td>{% if paginatedDevice.owner.getNotManuallyManagedGroups is defined %}{{ paginatedDevice.owner.getNotManuallyManagedGroups|join(', ') }}{% endif %}</td>
                    <td>{{ paginatedDevice.lastInfoUpdate|date('d/m/Y H:i') }}</td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
        <br class="hidden-md hidden-lg" />
        <div class="row">
            <div class="col-md-4">
                <div class="navigation" style="margin: -20px 0;">
                    {{ knp_pagination_render(paginatedDevices) }}
                </div>
            </div>
            <div class="col-md-8">
                <form class="form-search" action="{{ path('mdm_device_list') }}">
                    <div class="row">
                        <div class="col-sm-4 mb-1">
                            <select id="fromDep" name="fromDep" class="form-select">
                                <option value="">Tutte le provenienze</option>
                                <option value="1" {{ ((filters.fromDep is defined) and (filters.fromDep == "1"))?"selected" }}>Solo da Dep</option>
                                <option value="0" {{ ((filters.fromDep is defined) and (filters.fromDep == "0"))?"selected" }}>Non dal Dep</option>
                            </select>
                        </div>
                        <div class="col-sm-4 mb-1">
                            <select id="ownerType" name="ownerType" class="form-select">
                                <option value="">Tutti i tipi di proprietari</option>
                                <option value="student" {{ ((filters.ownerType is defined) and (filters.ownerType == "student"))?"selected" }}>Studente</option>
                                <option value="teacher" {{ ((filters.ownerType is defined) and (filters.ownerType == "teacher"))?"selected" }}>Docente</option>
                                <option value="none" {{ ((filters.ownerType is defined) and (filters.ownerType == "none"))?"selected" }}>Nessun Proprietario</option>
                            </select>
                        </div>
                        <div class="col-sm-4 mb-1">
                            <div class="input-group">
                                <input type="text" id="q" name="q" class="form-control" placeholder="Cerca"
                                       value="{{ (filters.q is defined)?filters.q|escape('html') }}">
                                <span class="input-group-btn">
                                    <button class="btn btn-secondary" type="submit"><i class="fa-solid fa-magnifying-glass"></i></button>
                                </span>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-sm-4 mb-1">
                            <select id="supervised" name="supervised" class="form-select">
                                <option value="">Tutti gli stati di supervisione</option>
                                <option value="1" {{ ((filters.supervised is defined) and (filters.supervised == "1"))?"selected" }}>Supervisionato</option>
                                <option value="0" {{ ((filters.supervised is defined) and (filters.supervised == "0"))?"selected" }}>Non Supervisionato</option>
                            </select>
                        </div>
                        <div class="col-sm-4 mb-1">
                            <select id="mdmServer" name="mdmServer" class="form-select">
                                <option value="">Tutti server</option>
                                {% for mdmServer in mdmServers %}
                                    <option value="{{ mdmServer.id }}" {{ ((filters.mdmServer is defined) and (mdmServer.id==filters.mdmServer))?"selected" }}
                                    >{{ mdmServer.name }}</option>
                                {% endfor %}
                            </select>
                        </div>
                        <div class="col-sm-4 mb-1">
                            <div class="checkbox">
                                <input type="checkbox" value="1" name="moreDevices" id="moreDevices" {{ ((filters.moreDevices is defined) and (filters.moreDevices == "1"))?"checked" }}>
                                <label for="moreDevices">Possiede più di un dispositivo</label>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</main>
{% endblock %}

templates/mdm_device/show_students_without_device.html.twig
{% extends 'base.html.twig' %}

{% block body -%}
<main class='main-content'>
    <div id='mainContent'>

        <h1>Studenti senza Dispositivo ({{ paginatedStudents.getTotalItemCount }})</h1>

        <table class="table table-striped table-hover ">
            <thead>
            <tr>
                <th>Cognome</th>
                <th>Nome</th>
                <th>Username</th>
                <th>Provider</th>
                <th>Classe</th>
            </tr>
            </thead>
            <tbody>
            {% for student in paginatedStudents %}
                <tr>
                    <td>{{ student.lastname }}</td>
                    <td>{{ student.firstname }}</td>
                    <td>{{ student.username }}</td>
                    <td>{{ student.provider.name }}</td>
                    <td>{{ student.notManuallyManagedGroups|join(", ") }}</td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
        <div class="row">
            <div class="col-md-4 text-center text-md-start">
                <div class="navigation">
                    {{ knp_pagination_render(paginatedStudents) }}
                </div>
            </div>
            <div class="col-md-4 text-center"></div>
            <div class="col-md-4 text-right">
                <form class="form-search" action="{{ path('mdm_device_show_student_without_device') }}">
                    <div class="mb-3 d-flex justify-content-center justify-content-md-end">
                        <select style="width: inherit; display: inline;" id="providerId" name="providerId"
                                class="form-select me-1">
                            <option value="">Tutti i provider</option>
                            {% for provider in providers %}
                                <option value="{{ provider.id }}" {{ ((filters.providerId is defined) and (provider.id==filters.providerId))?"selected" }}
                                >{{ provider.name }}</option>
                            {% endfor %}
                        </select>
                        <select style="width: inherit; display: inline;" id="groupId" name="groupId"
                                class="form-select me-1">
                            <option value="">Tutti i gruppi</option>
                            {% for group in groups %}
                                <option value="{{ group.id }}" {{ ((filters.groupId is defined) and (group.id==filters.groupId))?"selected" }}
                                >{{ group.name }} ({{ group.provider.name }})</option>
                            {% endfor %}
                        </select>
                        <button class="btn btn-secondary" type="submit"><i class="fa-solid fa-magnifying-glass"></i></button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</main>
{% endblock %}

templates/mdm_device/show_teachers_without_device.html.twig
{% extends 'base.html.twig' %}

{% block body -%}
<main class='main-content'>
    <div id='mainContent'>

        <h1>Docenti senza Dispositivo ({{ paginatedTeachers.getTotalItemCount }})</h1>

        <table class="table table-striped table-hover ">
            <thead>
            <tr>
                <th>Cognome</th>
                <th>Nome</th>
                <th>Username</th>
                <th>Provider</th>
            </tr>
            </thead>
            <tbody>
            {% for teacher in paginatedTeachers %}
                <tr>
                    <td>{{ teacher.lastname }}</td>
                    <td>{{ teacher.firstname }}</td>
                    <td>{{ teacher.username }}</td>
                    <td>{{ teacher.provider.name }}</td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
        <div class="row">
            <div class="col-md-4 text-center text-md-start">
                <div class="navigation" >
                    {{ knp_pagination_render(paginatedTeachers) }}
                </div>
            </div>
            <div class="col-md-4 text-center"></div>
            <div class="col-md-4">
                <form class="form-search" action="{{ path('mdm_device_show_teacher_without_device') }}">
                    <div class="mb-3 d-flex justify-content-center justify-content-md-end">
                        <select style="width: inherit; display: inline;" id="providerId" name="providerId"
                                class="form-select me-1">
                            <option value="">Tutti i provider</option>
                            {% for provider in providers %}
                                <option value="{{ provider.id }}" {{ ((filters.providerId is defined) and (provider.id==filters.providerId))?"selected" }}
                                >{{ provider.name }}</option>
                            {% endfor %}
                        </select>
                        <button class="btn btn-secondary" type="submit"><i class="fa-solid fa-magnifying-glass"></i></button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</main>
{% endblock %}